; CheckBox
; A box, either checked or unchecked, next to a single line of text.
;
; Functions:
; 1. guiDrawCheckBox
; 2. guiShowCheckBox
; 3. guiHideCheckBox
; 4. guiCheckCheckBox
; 5. guiUnCheckBox
;
; Comments:
;

CH_BigFont			equ	0
CH_Inverse			equ	1
CH_BoxOnRight		equ	2
CH_Checked			equ	3
CH_Showing			equ	4

guiShowCheckBox:
 inc hl
 inc hl
 set CH_Showing,(hl)
 dec hl
 dec hl
 jr guiDrawCheckBox
guiHideCheckBox:
 inc hl
 inc hl
 res CH_Showing,(hl)
 dec hl
 dec hl
 jr guiDrawCheckBox

guiCheckCheckBox:
 inc hl
 inc hl
 set CH_Checked,(hl)
 dec hl
 dec hl
 jr guiDrawCheckBox
guiUncheckCheckBox:
 inc hl
 inc hl
 res CH_Checked,(hl)
 dec hl
 dec hl

guiDrawCheckBox:
 ld de,pencol
 ldi
 ldi
 res fracDrawLFont,(iy+fontFlags)
 bit CH_BigFont,(hl)
 jr z,guiDrawCheckBoxSmall
 set fracDrawLFont,(iy+fontFlags)
guiDrawCheckBoxSmall:
 bit CH_Showing,(hl)
 jr z,guiEraseCheckBox
 res textInverse,(iy+textflags)
 bit CH_Inverse,(hl)
 jr z,guiDrawCheckBoxNotInverse
 set textInverse,(iy+textflags)
guiDrawCheckBoxNotInverse:
 bit CH_BoxOnRight,(hl)
 call z,guiDrawCheckBoxBox
 push hl
 inc hl
 call vputs2
 ld hl,pencol
 inc (hl)
 pop hl
 bit CH_BoxOnRight,(hl)
 call nz,guiDrawCheckBoxBox
 res fracDrawLFont,(iy+fontFlags)
 res textinverse,(iy+textflags)
 ret
guiDrawCheckBoxBox:
 push hl
 ld de,(pencol)
 ld bc,7*256+1
 bit CH_Inverse,(hl)
 jr nz,guiDrawCheckBoxBoxInverse
 ld ix,UncheckedBoxSprite
 bit CH_Checked,(hl)
 jr z,guiDrawCheckBoxGotPtr
 ld ix,CheckedBoxSprite
 jr guiDrawCheckBoxGotPtr
guiDrawCheckBoxBoxInverse:
 ld ix,UncheckedBoxInvSprite
 bit CH_Checked,(hl)
 jr z,guiDrawCheckBoxGotPtr
 ld ix,CheckedBoxInvSprite
guiDrawCheckBoxGotPtr:
 ld a,12	; ld sprite
 call guiDrawSprite
 B_CALL _grbufcpy
 ld hl,pencol
 ld a,9
 add a,(hl)
 ld (hl),a
 pop hl
 ret

guiEraseCheckBox:
 ld a,(hl)
 push af
 inc hl
 call pixlen
 res fracDrawLFont,(iy+fontFlags)
 res plotLoc,(iy+plotFlags)
 ld b,6
 bit CH_BigFont,a
 jr nz,guiEraseCheckBoxSmall
 inc b
guiEraseCheckBoxSmall:
 ld a,c
 add a,8
 ld c,a
 ld hl,(pencol)
 push hl
 add hl,bc
 ex de,hl
 pop hl
 pop af
 bit CH_Inverse,a
 jr nz,guiEraseCheckBoxFill
 B_CALL _clearrect
 ret
guiEraseCheckBoxFill:
 B_CALL _fillrect
 ret


UncheckedBoxSprite:
 db 11111110b
 db 10000010b
 db 10000010b
 db 10000010b
 db 10000010b
 db 10000010b
 db 11111110b

CheckedBoxSprite:
 db 11111110b
 db 10000010b
 db 10101010b
 db 10010010b
 db 10101010b
 db 10000010b
 db 11111110b

UncheckedBoxInvSprite:
 db 00000001b
 db 01111101b
 db 01111101b
 db 01111101b
 db 01111101b
 db 01111101b
 db 00000001b

CheckedBoxInvSprite:
 db 00000001b
 db 01111101b
 db 01010101b
 db 01101101b
 db 01010101b
 db 01111101b
 db 00000001b

guiHandleCheckBox:
 push de
 ld de,pencol
 ldi
 ldi
 pop de
 bit CH_Showing,(hl)
 ret z
 res fracDrawLFont,(iy+fontFlags)
 bit CH_BigFont,(hl)
 jr z,guiHandleCheckBoxSmall
 set fracDrawLFont,(iy+fontFlags)
guiHandleCheckBoxSmall:
 push hl
 pop ix
 inc hl
 call pixlen
 res fracDrawLFont,(iy+fontFlags)
 res plotLoc,(iy+plotFlags)
 ld b,6
 bit CH_BigFont,(ix)
 jr z,guiHandleCheckBoxSmall2
 inc b
guiHandleCheckBoxSmall2:
 ld a,c
 add a,8
 ld c,a
 ld hl,(pencol)
 push hl
 add hl,bc
 pop bc
 call IsInRectangle
 ret c
 push ix
 pop hl
 dec hl
 dec hl
 bit CH_Checked,(ix)
 push af
 call nz,guiUncheckCheckBox
 pop af
 call z,guiCheckCheckBox
 jp guiHandleClickFinished