; Label
; A single line of text.
;
; Functions:
; 1. guiDrawLabel			Checks the LA_Showing bit, and either draws the text or clears it accordingly.
; 2. guiShowLabel			Sets the LA_Showing bit, then calls guiDrawLabel
; 3. guiHideLabel			Resets the LA_Showing bit, then calls guiDrawLabel
;
; Comments:
; If the LA_Inverse flag is set, then hiding the label will make it black, otherwise
;  it will clear to white.
;

LA_BigFont			equ	0
LA_Inverse			equ	1
LA_Showing			equ	2

guiShowLabel:
 inc hl
 inc hl
 set LA_Showing,(hl)
 dec hl
 dec hl
 jr guiDrawLabel
guiHideLabel:
 inc hl
 inc hl
 res LA_Showing,(hl)
 dec hl
 dec hl
guiDrawLabel:
 ld de,pencol
 ldi
 ldi
 bit LA_Showing,(hl)
 jr z,guiEraseLabel
 res fracDrawLFont,(iy+fontFlags)
 bit LA_BigFont,(hl)
 jr z,guiDrawLabelSmall
 set fracDrawLFont,(iy+fontFlags)
guiDrawLabelSmall:
 res textInverse,(iy+textFlags)
 bit LA_Inverse,(hl)
 jr z,guiDrawLabelNotInverse
 set textInverse,(iy+textFlags)
guiDrawLabelNotInverse:
 inc hl
 call vputs2
 res fracDrawLFont,(iy+fontFlags)
 res textInverse,(iy+textFlags)
 ret

guiEraseLabel:
 push hl
 pop ix
 inc hl
 res fracDrawLFont,(iy+fontflags)
 bit LA_BigFont,(ix)
 jr z,guiEraseLabelSmall
 set fracDrawLFont,(iy+fontFlags)
guiEraseLabelSmall:
 call pixlen
 ld hl,(pencol)
 push hl
 add hl,bc
 ex de,hl
 pop hl
 res fracDrawLFont,(iy+fontFlags)
 res plotLoc,(iy+plotflags)
 res bufferonly,(iy+plotflag3)
 bit LA_Inverse,(ix)
 jr nz,guiEraseLabelInverse
 B_CALL _clearrect
 ret
guiEraseLabelInverse:
 B_CALL _fillrect
 ret

guiHandleLabel:
 inc hl
 inc hl
 bit LA_Showing,(hl)
 ret z
 dec hl
 dec hl
 push de
 ld e,(hl)
 inc hl
 ld d,(hl)
 inc hl
 res fracDrawLFont,(iy+fontFlags)
 bit LA_BigFont,(hl)
 jr z,guiHandleLableSmall
 set fracDrawLFont,(iy+fontFlags)
guiHandleLableSmall:
 inc hl
 call pixlen
 push de
 ex de,hl
 add hl,bc
 pop bc
 pop de
 res fracDrawLFont,(iy+fontFlags)
 call IsInRectangle
 ret c
 jp guiHandleClickFinished
