;
; G U I M A I N
;
; The app header, jumptable, appvar, and appvar installer.
; Includes all the other files.
;
; Note that this app has been ported out of ZDS and into TASM.
; In order for this to happen, a bunch of defines have to occur,
; as well as some changes to the b_call and other macro definitions.
; For this reason, I'm using the MirageOS supplied ti83plus.inc.
; If you wish to port it back, just switch the include file, remove
; the stuff at the beginning, and remove the preceding "_" from all
; b_calls (find & replace). Note that the command line to compile
; the app under TASM reads:
;   tasm -80 -i Main.asm GUI.hex
;


; Some stuff to port it out of zds into tasm
#define equ .equ
#define EQU .EQU
#define db .db
#define include .include
 .org 4000h
 .addinstr B_CALL * EF 3 NOP 1
#define bjump(xxxx) call 50h \ .dw xxxx
#define bcall(xxxx) rst 28h \ .dw xxxx

;Include file needed to access system routines
 .nolist
 include "ti83plus.inc"
 include "extraequ.inc"
 .list


;This is the application header definition area required for all apps.
 db 080h,0Fh    ;Field: Program length
 db   00h,00h,00h,00h ;Length=0 (N/A for unsigned apps)
 db 080h,012h    ;Field: Program type
 db   01h,04h  ;Type= Shareware, TI-83Plus
 db 080h,021h    ;Field: App ID
 db   01h       ;Id = 1
 db 080h,031h    ;Field: App Build
 db   01h       ;Build = 1
 db 080h,048h    ;Field: App Name
 db "GUI     "  ;Name = "GUI     " must be 8 characters
 db 080h,081h    ;Field: App Pages
 db 01h         ;App Pages = 1
 db 080h,090h    ;No default splash screen
 db 03h,026h ,09h,04h, 04h,06fh,01bh,80h     ;Field: Date stamp- 5/12/1999
 db 02h,0dh,040h                             ;Dummy encrypted TI date stamp signature
 db 0a1h ,06bh ,099h ,0f6h ,059h ,0bch ,067h 
 db 0f5h ,085h ,09ch ,09h ,06ch ,0fh ,0b4h ,03h ,09bh ,0c9h 
 db 03h ,032h ,02ch ,0e0h ,03h ,020h ,0e3h ,02ch ,0f4h ,02dh 
 db 073h ,0b4h ,027h ,0c4h ,0a0h ,072h ,054h ,0b9h ,0eah ,07ch 
 db 03bh ,0aah ,016h ,0f6h ,077h ,083h ,07ah ,0eeh ,01ah ,0d4h 
 db 042h ,04ch ,06bh ,08bh ,013h ,01fh ,0bbh ,093h ,08bh ,0fch 
 db 019h ,01ch ,03ch ,0ech ,04dh ,0e5h ,075h 
 db 80h,7Fh      ;Field: Program Image length
 db   0,0,0,0    ;Length=0, N/A
 db   0,0,0,0    ;Reserved
 db   0,0,0,0    ;Reserved
 db   0,0,0,0    ;Reserved
 db   0,0,0,0    ;Reserved
 
;End of header data

GUI_VERSION_01		EQU	1
GUI_VERSION_02		EQU	2

THIS_VERSION		EQU	GUI_VERSION_02

usableramcode			equ	812bh
guiPage				equ	814fh
guiMouseX			equ	8150h
guiMouseY			equ	8151h
guiMouseKey			equ	8152h
guiBkgdPtr			equ	8153h	; 2 bytes
guiDLPtr			equ	8155h	; 2 bytes
guiBkgd				equ	8100h

;The app starts here
 jp guiAppStart

Jumptable:
 jp guiInitialize
 jp guiVersion
 jp multilinetextL
 jp multilinetextC
 jp centertext
 jp nextstr
 jp guiMessageBox
 jp guiMessageBoxEX
 jp guiOptionBox
 jp guiOptionBoxEX
 jp guiInputBox
 jp guiInputBoxEX
 jp guiStringInput
 jp guiStringInputST
 jp guiWindow
 jp guiWindowEX
 jp guiMenu
 jp guiMenuEX
 jp guiDrawForm
 jp guiShowForm
 jp guiHideForm
 jp guiDrawLabel
 jp guiShowLabel
 jp guiHideLabel
 jp guiDrawPara
 jp guiShowPara
 jp guiHidePara
 jp guiDrawButton
 jp guiShowButton
 jp guiHideButton
 jp guiDrawCheckBox
 jp guiShowCheckBox
 jp guiHideCheckBox
 jp guiCheckCheckBox
 jp guiUncheckCheckBox
 jp guiDrawOptions
 jp guiShowOptions
 jp guiHideOptions
 jp guiSetOption
 jp guiDrawTextBox
 jp guiShowTextBox
 jp guiHideTextBox
 jp guiInputTextBox
 jp guiDrawBitmap
 jp guiDrawList
 jp guiShowList
 jp guiHideList
 jp guiSetList
 jp guiDrawDrop
 jp guiShowDrop
 jp guiHideDrop
 jp guiSetupMouse
 jp guiHandleMouse
 jp guiHandleClick
 jp guiDrawSprite

guiAppStart:
 ld hl,guiAppVar
 rst 20h
 B_CALL _chkfindsym
 jr c,Create
 B_CALL _delvararc
 ld hl,UnInstStr
 jr Done
Create:
 ld hl,guiAppVar
 rst 20h
 ld hl,AppVarDataEnd-AppVarDataStart+1
 B_CALL _CreateAppVar
 ld hl,AppVarDataStart
 ld bc,AppVarDataEnd-AppVarDataStart
 inc de
 inc de
 ldir
 in a,(6)
 ld (de),a
 ld hl,SuccessStr
Done:
 push hl
 B_CALL _clrlcdf
 B_CALL _homeup
 pop hl
 call PutS
 B_CALL _getkey
 bjump(_JForceCmdNoChar)

PutS:
 ld a,(hl)
 inc hl
 or a
 ret z
 B_CALL _PutC
 jr PutS

SuccessStr:
 db "GUI Installed!",0
UnInstStr:
 db "GUI Uninstalled!",0

guiAppVar:
 db 15h,"GUI",0

AppVarDataStart:
 in a,(6)
 ld b,a
 ld hl,AppVarDataEnd-AppVarDataStart
 add hl,de
 ld a,(hl)
 out (6),a
 ld hl,4012h
 ld a,(hl)
 inc hl
 cp 'G'
 scf
 ret nz
 ld a,(hl)
 inc hl
 cp 'U'
 scf
 ret nz
 ld a,(hl)
 cp 'I'
 scf
 ret nz
 call 4083h
 ld a,b
 out (6),a
 ret
AppVarDataEnd:

 include "Text.asm"		; Text display routines
 include "Init.asm"		; Initialization routines
 include "MessBox.asm"		; MessageBoxes
 include "OptBox.asm"		; OptionBoxes
 include "InputBox.asm"		; InputBoxes
 include "StrInput.asm"		; StringInput
 include "Window.asm"		; Basic Windows
 include "Menu.asm"		; Menu
 include "Sprite.asm"		; Sprite routines

 include "Form.asm"		; Form
 include "Label.asm"		; Label
 include "Para.asm"		; Paragraph
 include "Button.asm"		; Button
 include "CheckBox.asm"		; CheckBox
 include "Option.asm"		; Options
 include "TextBox.asm"		; Textbox
 include "Bitmap.asm"		; Bitmap
 include "List.asm"		; List
 include "DropList.asm"		; DropList

 include "Mouse.asm"		; Mouse

.end
END
